<script setup>
const config = useRuntimeConfig()

import { format } from 'date-fns';

import { ExistingCategory } from '~/adapters/category.js';
import { ExistingHolder } from '~/adapters/holder.js';
import { filter, filter_date, active_filter } from '~/directives/filter.js';

// The maximum number of letters to be displayed in removable buttons when applying a filter
const maxNbOfLetters = 25;

const filterPanels = reactive({
  datePanel: false,
  categoryPanel: false,
  organizerPanel: false,
  locationPanel: false,
  pricePanel: false
});

const emit = defineEmits(["filter"]);

const is_button_shining = computed(() => {
  return (filter.isActive() || active_filter.hasChanged() || filter_date.value != null);
})

// Fetch data
const { data: categories } = await useFetch(`${config.public.apiUrl}/categories`);
const { data: organizers } = await useFetch(`${config.public.apiUrl}/organizers`);
const { data: locations } = await useFetch(`${config.public.apiUrl}/locations-short`);

function toggleFilters(name) {
  Object.entries(filterPanels).forEach(([key]) => {
    if (key !== name) {
      filterPanels[key] = false;
    }
  });
  filterPanels[name] = !filterPanels[name];
}

function closeAll() {
  Object.entries(filterPanels).forEach(([key]) => {
    filterPanels[key] = false;
  });
}

function setDates() {
  if (filter_date != null && filter_date.value != null) {
    filter.date_filter.start_date = format(filter_date.value[0], "yyyy-MM-dd");
    filter.date_filter.end_date = format(filter_date.value[1], "yyyy-MM-dd");
    filter_date.value = null;
  }
}
function resetDates() {
  if (filter_date != null) {
    filter_date.value = null;
  }
}

// Transfer parameters to active_filter
function executeFilter() {
  closeAll();
  setDates();
  active_filter.feed(filter);
  filter.reset();
  emit("filter", active_filter.url_params);
}

function resetFilter() {
  closeAll();
  resetDates();
  filter.reset();
  active_filter.reset();
  emit("filter", "");
}

</script>
<template>
  <div class="absolute z-[2000]" aria-labelledby="Filtres" role="dialog" aria-modal="true">
    <div class="fixed inset-0 bg-gray-500/75 transition-opacity" aria-hidden="true"></div>
    <div class="fixed inset-0 z-10 w-screen overflow-y-auto">
      <div class="flex min-h-full items-start justify-center p-4 text-center">
        <menu class="flex flex-col bg-white w-full max-w-80 h-auto rounded-md mode-dark">
          <FiltersDropdown :name="'Dates'" :is_active="filterPanels['datePanel']"
            @toggle="toggleFilters('datePanel')" />
          <div v-if="filterPanels['datePanel']">
            <FiltersDPanel data-name="date" />
          </div>
          <ButtonRemovable v-if="active_filter.date_filter.isSet()" :name="active_filter.date_filter.display()"
            :class="'ml-8 mb-2'" @remove="active_filter.removeDate()" />
          <div class="flex flex-col">
            <FiltersDropdown :name="'Catégories'" :is_active="filterPanels['categoryPanel']"
              @toggle="toggleFilters('categoryPanel')" />
            <div v-if="filterPanels['categoryPanel']">
              <FormSearchList :list=categories :selected=filter.category_filter.getNameList()
                @add="(category) => filter.category_filter.register(new ExistingCategory(category.name, category.uid, category.parent))"
                @remove="(category) => filter.category_filter.removeByObject(new ExistingCategory(category.name, category.uid, category.parent))" />
            </div>
            <ButtonRemovable v-for="category in active_filter.category_filter.getList()" :is_main="false"
              :name="category.name" @remove="active_filter.removeCategory(category.uid)" :taille="maxNbOfLetters"
              :class="'ml-8 mb-2'" :uid="category.uid" :key="category.uid" />
          </div>
          <div class="flex flex-col">
            <FiltersDropdown :name="'Organisateur'" :is_active="filterPanels['organizerPanel']"
              @toggle="toggleFilters('organizerPanel')" />
            <div v-if="filterPanels['organizerPanel']">
              <FormSearchList :list="organizers" :selected=filter.organizer_filter.getOrganizerNameList()
                @add="(organizer) => filter.organizer_filter.register(new ExistingHolder(true, false, organizer.name, organizer.uid))"
                @remove="(organizer) => filter.organizer_filter.removeByObject(new ExistingHolder(true, false, organizer.name, organizer.uid))" />
            </div>
            <ButtonRemovable v-for="organizer in active_filter.organizer_filter.getList()" :is_main="false"
              :name="organizer.name" @remove="active_filter.removeOrganizer(organizer.uid)" :taille="maxNbOfLetters"
              :class="'ml-8 mb-2'" :uid="organizer.uid" :key="organizer.uid" />
          </div>
          <div class="flex flex-col">
            <FiltersDropdown :name="'Lieu'" :is_active="filterPanels['locationPanel']"
              @toggle="toggleFilters('locationPanel')" />
            <div v-if="filterPanels['locationPanel']">
              <FormSearchList :list="locations" :selected=filter.location_filter.getLocationNameList()
                @add="(location) => filter.location_filter.register(new ExistingHolder(false, true, location.name, location.uid))"
                @remove="(location) => filter.location_filter.removeByObject(new ExistingHolder(false, true, location.name, location.uid))" />
            </div>
            <ButtonRemovable v-for="location in active_filter.location_filter.getList()" :is_main="false"
              :name="location.name" @remove="active_filter.removeLocation(location.uid)" :taille="maxNbOfLetters"
              :class="'ml-8 mb-2'" :uid="location.uid" :key="location.uid" />
          </div>
          <div class="flex flex-col">
            <FiltersDropdown :name="'Prix'" :is_active="filterPanels['pricePanel']"
              @toggle="toggleFilters('pricePanel')" />
            <div v-if="filterPanels['pricePanel']">
              <FiltersPPanel data-name="price" />
            </div>
            <ButtonRemovable v-if="active_filter.price_filter.isSet()" :name="active_filter.price_filter.display()"
              :class="'ml-8 mb-2'" @remove="active_filter.removePrice()" />
          </div>
          <div class="flex flex-col space-y-2 py-4">
            <div class="mx-auto">
              <button
                class="w-[150px] py-2 border border-white text-xl bg-las-orange text-white rounded-full hover:bg-white hover:text-las-orange hover:border-las-orange"
                @click="executeFilter">
                Appliquer
              </button>
              <span v-if="is_button_shining" class="absolute inline-flex rounded-full h-3 w-3 bg-red-500"></span>
              <span v-if="is_button_shining"
                class="animate-ping absolute inline-flex rounded-full h-3 w-3 bg-red-500"></span>
            </div>
            <button class="w-[150px] mx-auto text-xl text-las-orange underline hover:no-underline" @click="resetFilter">
              Réinitialiser
            </button>
          </div>
        </menu>
      </div>
    </div>
  </div>
</template>